Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class MultiSearcher

    java.lang.Object
      org.apache.lucene.search.Searcher
          org.apache.lucene.search.MultiSearcher

All Implemented Interfaces:
  Remote, Searchable

Direct Known Subclasses:
  ParallelMultiSearcher

public class MultiSearcher
extends Searcher

Implements search over a set of `Searchables`.

Applications usually need only call the inherited `Searcher.search(Query)` or `Searcher.search(Query,Filter)` methods.

Constructor Summary
`MultiSearcher(Searchable[] searchables)` Creates a searcher which searches searchables.

Method Summary
`void` | `close()` Frees resources associated with this Searcher.
`Document` | `doc(int n)` Expert: Returns the stored fields of document `i`.
`int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
`Explanation` | `explain(Query query, int doc)` Returns an Explanation that describes how `doc` scored against `query`.
`protected int[]` | `getStarts()`
`int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
`Query` | `rewrite(Query original)` Expert: called to re-write queries into primitive queries.
`void` | `search(Query query, Filter filter, HitCollector results)` Lower-level search API.
`TopDocs` | `search(Query query, Filter filter, int nDocs)` Expert: Low-level search implementation.
`TopFieldDocs` | `search(Query query, Filter filter, int n, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.
`int` | `searcherIndex(int n)` Deprecated.
`int` | `subDoc(int n)` Returns the document number of document `n` within its sub-index.
`int` | `subSearcher(int n)` Returns index of the searcher for document `n` in the array used to construct this searcher.

Methods inherited from class org.apache.lucene.search.Searcher
`getSimilarity, search, search, search, search, search, setSimilarity`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MultiSearcher

    public MultiSearcher(Searchable[] searchables)
                  throws IOException

  Creates a searcher which searches searchables.

Method Detail

### getStarts

    protected int[] getStarts()

### close

    public void close()
               throws IOException

  Description copied from interface: `Searchable`
  Frees resources associated with this Searcher. Be careful not to call this method while you are still using objects like `Hits`.

  Throws:
    `IOException`

### docFreq

    public int docFreq(Term term)
                throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns the number of documents containing `term`. Called by search code to compute term weights.

  Throws:
    `IOException`
  See Also:
    `IndexReader.docFreq(Term).`

### doc

    public Document doc(int n)
                 throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns the stored fields of document `i`. Called by `HitCollector` implementations.

  Throws:
    `IOException`
  See Also:
    `IndexReader.document(int).`

### searcherIndex

    public int searcherIndex(int n)

  Deprecated.

  Call `subSearcher(int)` instead.

### subSearcher

    public int subSearcher(int n)

  Returns index of the searcher for document `n` in the array used to construct this searcher.

### subDoc

    public int subDoc(int n)

  Returns the document number of document `n` within its sub-index.

### maxDoc

    public int maxDoc()
               throws IOException

  Description copied from interface: `Searchable`
  Expert: Returns one greater than the largest possible document number. Called by search code to compute term weights.

  Throws:
    `IOException`
  See Also:
    `IndexReader.maxDoc().`

### search

    public TopDocs search(Query query,
                          Filter filter,
                          int nDocs)
                   throws IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

  Called by `Hits`.

  Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

  Throws:
    `IOException`

### search

    public TopFieldDocs search(Query query,
                               Filter filter,
                               int n,
                               Sort sort)
                        throws IOException

  Description copied from interface: `Searchable`
  Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `Searcher.search(Query,Filter,Sort)` instead.

  Throws:
    `IOException`

### search

    public void search(Query query,
                       Filter filter,
                       HitCollector results)
                throws IOException

  Description copied from interface: `Searchable`
  Lower-level search API.

  `HitCollector.collect(int,float)` is called for every non-zero scoring document.

  Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

  Parameters:
    `query` - to match documents
    `filter` - if non-null, a bitset used to eliminate some documents
    `results` - to receive hits
  Throws:
    `IOException`

### rewrite

    public Query rewrite(Query original)
                  throws IOException

  Description copied from interface: `Searchable`
  Expert: called to re-write queries into primitive queries.

  Throws:
    `IOException`

### explain

    public Explanation explain(Query query,
                               int doc)
                        throws IOException

  Description copied from interface: `Searchable`
  Returns an Explanation that describes how `doc` scored against `query`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2005 Apache Software Foundation. All Rights Reserved.